unit PElemzoU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Spin;

type
  TPElemzoF = class(TForm)
    Memo: TMemo;
    CPanel: TPanel;
    FEdit: TEdit;
    ReadFB: TButton;
    ElemezB: TButton;
    Img: TImage;
    Panel: TPanel;
    FromChar: TEdit;
    ToChar: TEdit;
    ChangeB: TButton;
    BgyFNE: TEdit;
    BgyFNL: TLabel;
    OD: TOpenDialog;
    procedure ReadFBClick(Sender: TObject);
    procedure FEditKeyPress(Sender: TObject; var Key: Char);
    procedure ElemezBClick(Sender: TObject);
    procedure ChangeBClick(Sender: TObject);
    procedure BgyFNEExit(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FEditDblClick(Sender: TObject);

  private
    GyakTabl, ConstTabl:array[0..255] of Integer;
  end;

var
  PElemzoF: TPElemzoF;

implementation

{$R *.DFM}

procedure TPElemzoF.ReadFBClick(Sender: TObject);
begin
  If FileExists(FEdit.Text) then
    Memo.Lines.LoadFromFile(FEdit.Text) else
    Begin
      MessageBeep(0);
      Memo.Lines.Clear;
    end;
end;

procedure TPElemzoF.FEditKeyPress(Sender: TObject; var Key: Char);
begin
  If Key=#13 then
  Begin
    Key:=#0;
    ReadFB.Click;
  end;
end;

procedure TPElemzoF.ElemezBClick(Sender: TObject);
var Max,CMax,i,j:integer;
begin
  For i:=0 to 255 do GyakTabl[i]:=0;
  For i:=0 to Memo.Lines.Count-1 do
    For j:=1 to Length(Memo.Lines[i]) do
      Inc(GyakTabl[Ord(Memo.Lines[i][j])]);
  Max:=0;
  For i:=Ord('A') to Ord('Z') do
    If Max<GyakTabl[i] then Max:=GyakTabl[i];
  CMax:=0;
  For i:=Ord('A') to Ord('Z') do
    If CMax<ConstTabl[i] then CMax:=ConstTabl[i];
  With Img.Canvas do
  Begin
    Brush.Color:=clGray;
    Pen.Color:=clGray;
    Rectangle(0,0,Img.Width,Img.Height);
    j:=(Img.Width-20) DIV 26;
    Font.Color:=clWhite;
    For i:=1 to 26 do
    Begin
      Brush.Color:=clGray;
      TextOut(i*j,Img.Height-20,Chr(i+64));
      Brush.Color:=clWhite;
      Pen.Color:=clWhite;
      FillRect(Rect(i*j, Img.Height-30,
                    i*j+5, Img.Height-30-GyakTabl[i+64]*(Img.Height-50) DIV Max));
      Brush.Color:=clRed;
      Pen.Color:=clRed;
      If ConstTabl[i+64]>0 then
        FillRect(Rect(i*j+6,Img.Height-30,
                      i*j+10,(Img.Height-30-ConstTabl[i+64]*(Img.Height-50) DIV CMax)));
    end;
  end;
end;

procedure TPElemzoF.ChangeBClick(Sender: TObject);
var i,j:integer; S:String;
begin
  Memo.Visible:=false;
  For i:=0 to Memo.Lines.Count-1 do
  Begin
    S:=Memo.Lines[i];
    For j:=1 to Length(S) do
      If S[j]=FromChar.Text[1] then S[j]:=ToChar.Text[1]
        else If S[j]=ToChar.Text[1] then S[j]:=FromChar.Text[1];
    Memo.Lines[i]:=S;
  end;
  Memo.Visible:=true;
  ElemezB.Click;
end;

procedure TPElemzoF.BgyFNEExit(Sender: TObject);
var i:integer; F:TextFile;
begin
  If FileExists('Betugyak.'+BgyFNE.Text) then
  Begin
    AssignFile(F,'Betugyak.'+BgyFNE.Text);
    Reset(F);
    For i:=65 to 65+25 do Readln(F,ConstTabl[i]);
    CloseFile(F);
  end;
end;

procedure TPElemzoF.FormShow(Sender: TObject);
begin
  BgyFNEExit(Self);
end;

procedure TPElemzoF.FEditDblClick(Sender: TObject);
begin
  If OD.Execute then
  begin
    FEdit.TExt:=OD.FileName;
    ReadFB.Click;
    ElemezB.Click;
  end;
end;


end.
